freeslot("SPR_FNFA", "SPR_FNFS", "S_ARROW_LEFT", "S_ARROW_DOWN", "S_ARROW_UP", "S_ARROW_RIGHT", "MT_FNF_ARROW")
freeslot("S_ARROW_LEFT_BUL", "S_ARROW_DOWN_BUL", "S_ARROW_UP_BUL", "S_ARROW_RIGHT_BUL")
freeslot("S_ARROW_LEFT_HURT", "S_ARROW_DOWN_HURT", "S_ARROW_UP_HURT", "S_ARROW_RIGHT_HURT")
freeslot("S_ARROW_LEFT_RING", "S_ARROW_DOWN_RING", "S_ARROW_UP_RING", "S_ARROW_RIGHT_RING")
freeslot("S_ARROW_LEFT_MON", "S_ARROW_DOWN_MON", "S_ARROW_UP_MON", "S_ARROW_RIGHT_MON")
freeslot("S_TUTORIAL_ICON", "S_TUTORIAL_BOX", "S_POPUP_A", "SPR_FNFP")
for i = 1, 10
freeslot("S_ARROW_SPLASH_A"..i, "S_ARROW_SPLASH_B"..i, "S_ARROW_SPLASH_C"..i, "S_ARROW_SPLASH_D"..i)
end
freeslot("S_FNF_SICK", "S_FNF_GOOD", "S_FNF_BAD", "S_FNF_SHIT", "SPR_FNFR", "MT_FNF_RATING")
for i = 1, 10
freeslot("S_FNF_COMBO_"..(i-1), "S_FNF_COMBO", "SPR_FNFC")
end
//freeslot("S_ARROW_HOLD", "S_ARROW_HOLD_END")

mobjinfo[MT_FNF_ARROW] = { //The Arrow Object that is used for: Input Arrow, Press Effects, Def Arrows.
	doomednum = -1,
	spawnstate = S_ARROW_LEFT,
	spawnhealth = 1,
	speed = 0,
	radius = 24*FRACUNIT,
	height = 1,
	dispoffset = 0,
	reactiontime = 2,
	mass = 0,
	damage = 0,
	flags = MF_NOGRAVITY|MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP|MF_NOCLIPTHING
}
mobjinfo[MT_FNF_RATING] = { //The Arrow Object that is used for: Input Arrow, Press Effects, Def Arrows.
	doomednum = -1,
	spawnstate = S_FNF_SICK,
	spawnhealth = 1,
	speed = 0,
	radius = 50*FRACUNIT,
	height = 24,
	dispoffset = 0,
	reactiontime = 2,
	mass = 0,
	damage = 0,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP|MF_NOCLIPTHING
}

states[S_ARROW_LEFT] = {SPR_FNFA, A, 2, nil, 0, 0, S_ARROW_LEFT} //States for Default Arrows
states[S_ARROW_DOWN] = {SPR_FNFA, B, 2, nil, 0, 0, S_ARROW_DOWN}
states[S_ARROW_UP] = {SPR_FNFA, C, 2, nil, 0, 0, S_ARROW_UP}
states[S_ARROW_RIGHT] = {SPR_FNFA, D, 2, nil, 0, 0, S_ARROW_RIGHT}

states[S_ARROW_LEFT_HURT] = {SPR_FNFA, E, 2, nil, 0, 0, S_ARROW_LEFT_HURT} //States for Hurt Arrows
states[S_ARROW_DOWN_HURT] = {SPR_FNFA, F, 2, nil, 0, 0, S_ARROW_DOWN_HURT}
states[S_ARROW_UP_HURT] = {SPR_FNFA, G, 2, nil, 0, 0, S_ARROW_UP_HURT}
states[S_ARROW_RIGHT_HURT] = {SPR_FNFA, H, 2, nil, 0, 0, S_ARROW_RIGHT_HURT}

states[S_ARROW_LEFT_BUL] = {SPR_FNFA, I, 2, nil, 0, 0, S_ARROW_LEFT_BUL} //States for Bullet Arrows
states[S_ARROW_DOWN_BUL] = {SPR_FNFA, J, 2, nil, 0, 0, S_ARROW_DOWN_BUL}
states[S_ARROW_UP_BUL] = {SPR_FNFA, K, 2, nil, 0, 0, S_ARROW_UP_BUL}
states[S_ARROW_RIGHT_BUL] = {SPR_FNFA, L, 2, nil, 0, 0, S_ARROW_RIGHT_BUL}

states[S_ARROW_LEFT_RING] = {SPR_FNFA, M, 2, nil, 0, 0, S_ARROW_LEFT_RING} //States for Ring Arrows
states[S_ARROW_DOWN_RING] = {SPR_FNFA, N, 2, nil, 0, 0, S_ARROW_DOWN_RING}
states[S_ARROW_UP_RING] = {SPR_FNFA, O, 2, nil, 0, 0, S_ARROW_UP_RING}
states[S_ARROW_RIGHT_RING] = {SPR_FNFA, P, 2, nil, 0, 0, S_ARROW_RIGHT_RING}

states[S_ARROW_LEFT_MON] = {SPR_FNFA, Q, 2, nil, 0, 0, S_ARROW_LEFT_MON} //States for Monitor Arrows
states[S_ARROW_DOWN_MON] = {SPR_FNFA, R, 2, nil, 0, 0, S_ARROW_DOWN_MON}
states[S_ARROW_UP_MON] = {SPR_FNFA, S, 2, nil, 0, 0, S_ARROW_UP_MON}
states[S_ARROW_RIGHT_MON] = {SPR_FNFA, T, 2, nil, 0, 0, S_ARROW_RIGHT_MON}

states[S_ARROW_SPLASH_A1] = {SPR_FNFS, A, 2, nil, 0, 0, S_ARROW_SPLASH_A2} //Arrow splashes
states[S_ARROW_SPLASH_A2] = {SPR_FNFS, B, 2, nil, 0, 0, S_ARROW_SPLASH_A3}
states[S_ARROW_SPLASH_A3] = {SPR_FNFS, C, 2, nil, 0, 0, S_ARROW_SPLASH_A4}
states[S_ARROW_SPLASH_A4] = {SPR_FNFS, D, 2, nil, 0, 0, S_NULL}

states[S_ARROW_SPLASH_B1] = {SPR_FNFS, E, 2, nil, 0, 0, S_ARROW_SPLASH_B2}
states[S_ARROW_SPLASH_B2] = {SPR_FNFS, F, 2, nil, 0, 0, S_ARROW_SPLASH_B3}
states[S_ARROW_SPLASH_B3] = {SPR_FNFS, G, 2, nil, 0, 0, S_ARROW_SPLASH_B4}
states[S_ARROW_SPLASH_B4] = {SPR_FNFS, H, 2, nil, 0, 0, S_NULL}

states[S_ARROW_SPLASH_C1] = {SPR_FNFS, I, 2, nil, 0, 0, S_ARROW_SPLASH_C2} //Hurt splash
states[S_ARROW_SPLASH_C2] = {SPR_FNFS, J, 2, nil, 0, 0, S_ARROW_SPLASH_C3}
states[S_ARROW_SPLASH_C3] = {SPR_FNFS, K, 2, nil, 0, 0, S_ARROW_SPLASH_C4}
states[S_ARROW_SPLASH_C4] = {SPR_FNFS, L, 2, nil, 0, 0, S_NULL}

states[S_ARROW_SPLASH_D1] = {SPR_BOM1, A, 2, nil, 0, 0, S_ARROW_SPLASH_D2} //Monitor explode
states[S_ARROW_SPLASH_D2] = {SPR_BOM1, B, 2, nil, 0, 0, S_ARROW_SPLASH_D3}
states[S_ARROW_SPLASH_D3] = {SPR_BOM1, C, 2, nil, 0, 0, S_ARROW_SPLASH_D4}
states[S_ARROW_SPLASH_D4] = {SPR_BOM1, D, 2, nil, 0, 0, S_ARROW_SPLASH_D5}
states[S_ARROW_SPLASH_D5] = {SPR_BOM1, E, 2, nil, 0, 0, S_ARROW_SPLASH_D6}
states[S_ARROW_SPLASH_D6] = {SPR_BOM1, F, 2, nil, 0, 0, S_NULL}

states[S_FNF_SICK] = {SPR_FNFR, A, 20, nil, 0, 0, S_FNF_SICK} //Sick Rating
states[S_FNF_GOOD] = {SPR_FNFR, B, 20, nil, 0, 0, S_FNF_GOOD} //Good Rating
states[S_FNF_BAD] = {SPR_FNFR, C, 20, nil, 0, 0, S_FNF_BAD} //Bad Rating 
states[S_FNF_SHIT] = {SPR_FNFR, D, 20, nil, 0, 0, S_FNF_SHIT} //Shit Rating

states[S_FNF_COMBO] = {SPR_FNFC, A, 20, nil, 0, 0, S_FNF_COMBO} //Combo Text
states[S_FNF_COMBO_0] = {SPR_FNFC, B, 20, nil, 0, 0, S_FNF_COMBO_0} //0
states[S_FNF_COMBO_1] = {SPR_FNFC, C, 20, nil, 0, 0, S_FNF_COMBO_1} //1
states[S_FNF_COMBO_2] = {SPR_FNFC, D, 20, nil, 0, 0, S_FNF_COMBO_2} //2
states[S_FNF_COMBO_3] = {SPR_FNFC, E, 20, nil, 0, 0, S_FNF_COMBO_3} //3
states[S_FNF_COMBO_4] = {SPR_FNFC, F, 20, nil, 0, 0, S_FNF_COMBO_4} //4
states[S_FNF_COMBO_5] = {SPR_FNFC, G, 20, nil, 0, 0, S_FNF_COMBO_5} //5
states[S_FNF_COMBO_6] = {SPR_FNFC, H, 20, nil, 0, 0, S_FNF_COMBO_6} //6
states[S_FNF_COMBO_7] = {SPR_FNFC, I, 20, nil, 0, 0, S_FNF_COMBO_7} //7
states[S_FNF_COMBO_8] = {SPR_FNFC, J, 20, nil, 0, 0, S_FNF_COMBO_8} //8
states[S_FNF_COMBO_9] = {SPR_FNFC, K, 20, nil, 0, 0, S_FNF_COMBO_9} //9

//states[S_ARROW_HOLD] = {SPR_FNFA, M, 2, nil, 0, 0, S_ARROW_HOLD}
//states[S_ARROW_HOLD_END] = {SPR_FNFA, N, 2, nil, 0, 0, S_ARROW_HOLDEND}

states[S_TUTORIAL_BOX] = {SPR_TVTU, A, 2, nil, 0, 0, S_TUTORIAL_BOX}
states[S_TUTORIAL_ICON] = {SPR_TVTU, C, 4, nil, 0, 0, S_NULL}

states[S_POPUP_A] = {SPR_FNFP, A, 35, nil, 0, 0, S_NULL}

addHook("ThinkFrame", do //Make Arrows Transparent if you completely missed them
	for mo in mobjs.iterate()
		if mo and mo.valid and mo.type == MT_FNF_ARROW
			if mo.scale < (FRACUNIT - FRACUNIT/3)
				mo.frame = $|FF_TRANS90
			end
			if mo.appear //Make notes fade out of nowhere
				mo.appear = $ - 1
				if mo.appear == 10
					mo.frame = $|FF_TRANS90
				end
				if mo.appear == 9
					mo.frame = $|FF_TRANS80
				end
				if mo.appear == 8
					mo.frame = $|FF_TRANS70
				end
				if mo.appear == 7
					mo.frame = $|FF_TRANS60
				end
				if mo.appear == 6
					mo.frame = $|FF_TRANS50
				end
				if mo.appear == 5
					mo.frame = $|FF_TRANS40
				end
				if mo.appear == 4
					mo.frame = $|FF_TRANS30
				end
				if mo.appear == 3
					mo.frame = $|FF_TRANS10
				end
				if mo.appear == 2
					mo.frame = $|FF_TRANS10
				end
				if mo.appear == 1
					mo.appear = 0
					mo.frame = $ & ~(FF_TRANS90|FF_TRANS80|FF_TRANS70|FF_TRANS60|FF_TRANS50|FF_TRANS40|FF_TRANS30|FF_TRANS20|FF_TRANS10)
				end
			end
		end
		if mo and mo.valid and mo.type == MT_FNF_RATING
			mo.momz = FixedMul($, 9*FRACUNIT/10)
			if mo.fuse
				if mo.fuse == 9
					mo.frame = $|FF_TRANS10
				end
				if mo.fuse == 8
					mo.frame = $|FF_TRANS20
				end
				if mo.fuse == 7
					mo.frame = $|FF_TRANS30
				end
				if mo.fuse == 6
					mo.frame = $|FF_TRANS40
				end
				if mo.fuse == 5
					mo.frame = $|FF_TRANS50
				end
				if mo.fuse == 4
					mo.frame = $|FF_TRANS60
				end
				if mo.fuse == 3
					mo.frame = $|FF_TRANS70
				end
				if mo.fuse == 2
					mo.frame = $|FF_TRANS80
				end
				if mo.fuse == 1
					mo.frame = $|FF_TRANS90
				end
			end
		end
	end
end)

local DISTARW = 60*FRACUNIT

addHook("MobjThinker", function(mo)
	if mo and mo.target and mo.dirarw
		local camangle = R_PointToAngle(mo.target.x, mo.target.y)
		local addangle = ANGLE_90*mo.dirarw
		
		local gotox = mo.target.x + FixedMul(DISTARW, cos(camangle+addangle))
		local gotoy = mo.target.y + FixedMul(DISTARW, sin(camangle+addangle))
		
		if P_MobjFlip(mo.target) == 1
			mo.renderflags = $ & ~RF_VERTICALFLIP
			P_TeleportMove(mo, gotox, gotoy, mo.target.z+FRACUNIT*4)
		else
			mo.renderflags = $|RF_VERTICALFLIP
			P_TeleportMove(mo, gotox, gotoy, (mo.target.z+mo.target.height)-FRACUNIT*4)
		end
		
		/*if mo.arwtype == 5
			mo.spriteyoffset = $ - 5
		end*/
		
		/*if mo.arwtype == 6
			mo.rollangle = $ + 15*ANG1
		elseif mo.arwtype == 7
			mo.rollangle = $ - 15*ANG1
		end*/
		if (mo.dirarw >= 17 and mo.dirarw <= 20)
		or mo.arwtype == 4
			if not mo.power
				mo.power = P_SpawnMobjFromMobj(mo, 0, 0, FRACUNIT, MT_OVERLAY)
				mo.power.spriteyoffset = -7*FRACUNIT
				mo.power.target = mo
				mo.power.tracer = mo
				mo.power.state = S_TUTORIAL_ICON
			elseif (mo.power and mo.power.valid)
				mo.power.spriteyoffset = -7*FRACUNIT
				mo.power.flags2 = mo.flags2
				mo.power.frame = mo.frame
				mo.power.scale = mo.scale
				mo.power.color = mo.color
				mo.power.tics = 15
				mo.power.frame = C
				mo.power.rollangle = mo.rollangle
				mo.power.renderflags = mo.renderflags
				//mo.power.momz = FRACUNIT*P_MobjFlip(mo.target)
				if mo.montype
					mo.power.state = mobjinfo[mo.montype].spawnstate
					mo.power.tics = 15
					mo.power.frame = C
				else
					mo.power.state = S_TUTORIAL_ICON
					mo.power.tics = 15
					mo.power.frame = C
				end	
				if (leveltime%1) >= 1
					mo.power.flags2 = $|MF2_DONTDRAW
				else
					mo.power.flags2 = $ & ~MF2_DONTDRAW
				end
				mo.power.tics = 15
				mo.power.frame = C
			end
		end
		if mo.target.player and mo.target.player.playerstate == PST_DEAD
			P_KillMobj(mo)
		end
	end
end, MT_FNF_ARROW)